.386
.model flat, stdcall
	include windows.inc
	include kernel32.inc

	include pmacros100.inc
.code
; simple function, that returns the value passed to it
;	mov eax, dword ptr [esp + 4]
;	retn 4
func func0, value:DWORD
	mov eax, [PARAM value]
	ret
endf func0

; function that puts the value to local variable
;	push ecx	; this is used instead of sub esp, 4
;	mov eax, dword ptr [esp + 8]
;	mov dword ptr [esp], eax
;	pop ecx		; this is used instead of add esp, 4
;	retn 4
	LOCALS something:DWORD
func func1, value:DWORD
	mov eax, [PARAM value]
	mov [LOCAL something], eax
	ret
endf func1

; function that calls func0, and also preserves ebx
;	push ebx
;	push dword ptr [esp + 8]
;	call func0
;	pop ebx
;	retn 4
func func2, uses ebx, value:DWORD
	fncall func0, [PARAM value]
	ret
endf func2

; function that pushes value to stack, and uses param
;	push ebx
;	mov eax, dword tpr [esp + 8]
;	push eax
;	push dword ptr [esp + C]
;	call func0
;	pop eax
;	pop ebx
;	retn 8
func func3, uses ebx, value0:DWORD, value1:DWORD
	mov eax, [PARAM value0]
	
	_push eax	; push the value to stack with the special _push, this makes sure the PARAM keyword works
	
	fncall func0, [PARAM value0]
	
	_pop eax	; pop the value from stack
	
	ret
endf func3

; function that moves registers to stack
;	mov dword ptr [esp - 4], ebx
;	mov dword ptr [esp - 8], edi
;	sub esp, 8
;	nop
;	mov edi, dword ptr [esp]
;	mov ebx, dword ptr [esp + 4]
;	add esp, 8
;	retn
func func4, MOVE, uses ebx edi
	nop
	ret
endf func4

; function that makes an fnjmp
;	push OFFSET lbl0
;	jmp func4
;lbl0:
;	retn
func func5
	fnjmp <lbl0>, func4
	int 3h	; this is never reached
lbl0:
	ret
endf func5

start:
	fncall func0, 555
	fncall func1, 655
	fncall func2, 593
	fncall func3, 30, 1.0
	fncall func5
	
	fncall ExitProcess, 0
end start